diff --git a/gcc/config/arm/arm.c b/gcc/config/arm/arm.c
index 0240cc7..6ee138e 100644
--- a/gcc/config/arm/arm.c
+++ b/gcc/config/arm/arm.c
@@ -18632,8 +18632,8 @@ arm_compute_save_reg0_reg12_mask (void)
 	  save_reg_mask |= (1 << reg);
 
       /* Also save the pic base register if necessary.  */
-      if (flag_pic
-	  && !TARGET_SINGLE_PIC_BASE
+      if (GCC_OPTION (flag_pic)
+	  && !GCC_OPTION (TARGET_SINGLE_PIC_BASE)
 	  && arm_pic_register != INVALID_REGNUM
 	  && crtl->uses_pic_offset_table)
 	save_reg_mask |= 1 << PIC_OFFSET_TABLE_REGNUM;
@@ -18666,8 +18666,8 @@ arm_compute_save_reg0_reg12_mask (void)
 
       /* If we aren't loading the PIC register,
 	 don't stack it even though it may be live.  */
-      if (flag_pic
-	  && !TARGET_SINGLE_PIC_BASE
+      if (GCC_OPTION (flag_pic)
+	  && !GCC_OPTION (TARGET_SINGLE_PIC_BASE)
 	  && arm_pic_register != INVALID_REGNUM
 	  && (df_regs_ever_live_p (PIC_OFFSET_TABLE_REGNUM)
 	      || crtl->uses_pic_offset_table))
@@ -18760,7 +18760,7 @@ arm_compute_save_reg_mask (void)
      if we know that we will not need a fancy return sequence.  */
   if (df_regs_ever_live_p (LR_REGNUM)
       || (save_reg_mask
-	  && optimize_size
+	  && GCC_OPTION (optimize_size)
 	  && ARM_FUNC_TYPE (func_type) == ARM_FT_NORMAL
 	  && !crtl->calls_eh_return))
     save_reg_mask |= 1 << LR_REGNUM;
@@ -18798,7 +18798,7 @@ arm_compute_save_reg_mask (void)
 
   /* We may need to push an additional register for use initializing the
      PIC base register.  */
-  if (TARGET_THUMB2 && IS_NESTED (func_type) && flag_pic
+  if (TARGET_THUMB2 && IS_NESTED (func_type) && GCC_OPTION (flag_pic)
       && (save_reg_mask & THUMB2_WORK_REGS) == 0)
     {
       reg = thumb_find_work_register (1 << 4);
@@ -18823,8 +18823,8 @@ thumb1_compute_save_reg_mask (void)
     if (df_regs_ever_live_p (reg) && !call_used_regs[reg])
       mask |= 1 << reg;
 
-  if (flag_pic
-      && !TARGET_SINGLE_PIC_BASE
+  if (GCC_OPTION (flag_pic)
+      && !GCC_OPTION (TARGET_SINGLE_PIC_BASE)
       && arm_pic_register != INVALID_REGNUM
       && crtl->uses_pic_offset_table)
     mask |= 1 << PIC_OFFSET_TABLE_REGNUM;
@@ -20856,7 +20856,7 @@ arm_expand_prologue (void)
       unsigned long dwarf_regs_mask = live_regs_mask;
 
       saved_regs += bit_count (live_regs_mask) * 4;
-      if (optimize_size && !frame_pointer_needed
+      if (GCC_OPTION (optimize_size) && !frame_pointer_needed
 	  && saved_regs == offsets->saved_regs - offsets->saved_args)
 	{
 	  /* If no coprocessor registers are being pushed and we don't have
@@ -20937,7 +20937,7 @@ arm_expand_prologue (void)
 	}
     }
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size
       = offsets->outgoing_args - offsets->saved_args;
 
@@ -20971,7 +20971,7 @@ arm_expand_prologue (void)
   if (frame_pointer_needed && TARGET_THUMB2)
     thumb_set_frame_pointer (offsets);
 
-  if (flag_pic && arm_pic_register != INVALID_REGNUM)
+  if (GCC_OPTION (flag_pic) && arm_pic_register != INVALID_REGNUM)
     {
       unsigned long mask;
 
@@ -20987,7 +20987,7 @@ arm_expand_prologue (void)
      scheduling in the prolog.  Similarly if we want non-call exceptions
      using the EABI unwinder, to prevent faulting instructions from being
      swapped with a stack adjustment.  */
-  if (crtl->profile || !TARGET_SCHED_PROLOG
+  if (crtl->profile || !GCC_OPTION (TARGET_SCHED_PROLOG)
       || (arm_except_unwind_info (&global_options) == UI_TARGET
 	  && cfun->can_throw_non_call_exceptions))
     emit_insn (gen_blockage ());
@@ -21858,12 +21858,12 @@ arm_assemble_integer (rtx x, unsigned int size, int aligned_p)
 
       /* Mark symbols as position independent.  We only do this in the
 	 .text segment, not in the .data segment.  */
-      if (NEED_GOT_RELOC && flag_pic && making_const_table &&
+      if (NEED_GOT_RELOC && GCC_OPTION (flag_pic) && making_const_table &&
 	  (GET_CODE (x) == SYMBOL_REF || GET_CODE (x) == LABEL_REF))
 	{
 	  /* See legitimize_pic_address for an explanation of the
 	     TARGET_VXWORKS_RTP check.  */
-	  if (!arm_pic_data_is_text_relative
+	  if (!GCC_OPTION (arm_pic_data_is_text_relative)
 	      || (GET_CODE (x) == SYMBOL_REF && !SYMBOL_REF_LOCAL_P (x)))
 	    fputs ("(GOT)", asm_out_file);
 	  else
@@ -22453,7 +22453,7 @@ arm_final_prescan_insn (rtx insn)
 		 StrongARM), but still allow this if optimizing for size.  */
 	      else if (GET_CODE (scanbody) == return_code
 		       && !use_return_insn (TRUE, NULL)
-		       && !optimize_size)
+		       && !GCC_OPTION (optimize_size))
 		fail = TRUE;
 	      else if (GET_CODE (scanbody) == return_code)
 	        {
@@ -24519,7 +24519,7 @@ arm_init_builtins (void)
   if (TARGET_NEON)
     arm_init_neon_builtins ();
 
-  if (arm_fp16_format)
+  if (GCC_OPTION (arm_fp16_format))
     arm_init_fp16_builtins ();
 
   if (TARGET_CRC32)
@@ -24594,7 +24594,7 @@ static bool
 arm_scalar_mode_supported_p (enum machine_mode mode)
 {
   if (mode == HFmode)
-    return (arm_fp16_format != ARM_FP16_FORMAT_NONE);
+    return (GCC_OPTION (arm_fp16_format) != ARM_FP16_FORMAT_NONE);
   else if (ALL_FIXED_POINT_MODE_P (mode))
     return true;
   else
@@ -26153,7 +26153,7 @@ thumb_exit (FILE *f, int reg_containing_return_addr)
 void
 thumb1_final_prescan_insn (rtx insn)
 {
-  if (flag_print_asm_name)
+  if (GCC_OPTION (flag_print_asm_name))
     asm_fprintf (asm_out_file, "%@ 0x%04x\n",
 		 INSN_ADDRESSES (INSN_UID (insn)));
   /* Don't overwrite the previous setter when we get to a cbranch.  */
@@ -26349,7 +26349,7 @@ thumb1_extra_regs_pushed (arm_stack_offsets *offsets, bool for_prologue)
   /* If the stack frame size is 512 exactly, we can save one load
      instruction, which should make this a win even when optimizing
      for speed.  */
-  if (!optimize_size && amount != 512)
+  if (!GCC_OPTION (optimize_size) && amount != 512)
     return 0;
 
   /* Can't do this if there are high registers to push.  */
@@ -26370,7 +26370,7 @@ thumb1_extra_regs_pushed (arm_stack_offsets *offsets, bool for_prologue)
   /* Don't do this if thumb_expand_prologue wants to emit instructions
      between the push and the stack frame allocation.  */
   if (for_prologue
-      && ((flag_pic && arm_pic_register != INVALID_REGNUM)
+      && ((GCC_OPTION (flag_pic) && arm_pic_register != INVALID_REGNUM)
 	  || (!frame_pointer_needed && CALLER_INTERWORKING_SLOT_SIZE > 0)))
     return 0;
 
@@ -26899,14 +26899,14 @@ thumb1_expand_prologue (void)
 
   /* Load the pic register before setting the frame pointer,
      so we can use r7 as a temporary work register.  */
-  if (flag_pic && arm_pic_register != INVALID_REGNUM)
+  if (GCC_OPTION (flag_pic) && arm_pic_register != INVALID_REGNUM)
     arm_load_pic_register (live_regs_mask);
 
   if (!frame_pointer_needed && CALLER_INTERWORKING_SLOT_SIZE > 0)
     emit_move_insn (gen_rtx_REG (Pmode, ARM_HARD_FRAME_POINTER_REGNUM),
 		    stack_pointer_rtx);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size
       = offsets->outgoing_args - offsets->saved_args;
 
@@ -26967,7 +26967,7 @@ thumb1_expand_prologue (void)
      scheduling in the prolog.  Similarly if we want non-call exceptions
      using the EABI unwinder, to prevent faulting instructions from being
      swapped with a stack adjustment.  */
-  if (crtl->profile || !TARGET_SCHED_PROLOG
+  if (crtl->profile || !GCC_OPTION (TARGET_SCHED_PROLOG)
       || (arm_except_unwind_info (&global_options) == UI_TARGET
 	  && cfun->can_throw_non_call_exceptions))
     emit_insn (gen_blockage ());
@@ -27067,7 +27067,7 @@ thumb1_expand_epilogue (void)
      the stack adjustment will not be deleted.  */
   emit_insn (gen_force_register_use (stack_pointer_rtx));
 
-  if (crtl->profile || !TARGET_SCHED_PROLOG)
+  if (crtl->profile || !GCC_OPTION (TARGET_SCHED_PROLOG))
     emit_insn (gen_blockage ());
 
   /* Emit a clobber for each insn that will be restored in the epilogue,
@@ -27887,7 +27887,7 @@ void
 arm_emit_eabi_attribute (const char *name, int num, int val)
 {
   asm_fprintf (asm_out_file, "\t.eabi_attribute %d, %d", num, val);
-  if (flag_verbose_asm || flag_debug_asm)
+  if (GCC_OPTION (flag_verbose_asm) || GCC_OPTION (flag_debug_asm))
     asm_fprintf (asm_out_file, "\t%s %s", ASM_COMMENT_START, name);
   asm_fprintf (asm_out_file, "\n");
 }
@@ -27964,42 +27964,42 @@ arm_file_start (void)
          are used.  However we don't have any easy way of figuring this out.
 	 Conservatively record the setting that would have been used.  */
 
-      if (flag_rounding_math)
+      if (GCC_OPTION (flag_rounding_math))
 	arm_emit_eabi_attribute ("Tag_ABI_FP_rounding", 19, 1);
 
-      if (!flag_unsafe_math_optimizations)
+      if (!GCC_OPTION (flag_unsafe_math_optimizations))
 	{
 	  arm_emit_eabi_attribute ("Tag_ABI_FP_denormal", 20, 1);
 	  arm_emit_eabi_attribute ("Tag_ABI_FP_exceptions", 21, 1);
 	}
-      if (flag_signaling_nans)
+      if (GCC_OPTION (flag_signaling_nans))
 	arm_emit_eabi_attribute ("Tag_ABI_FP_user_exceptions", 22, 1);
 
       arm_emit_eabi_attribute ("Tag_ABI_FP_number_model", 23,
-			   flag_finite_math_only ? 1 : 3);
+			   GCC_OPTION (flag_finite_math_only) ? 1 : 3);
 
       arm_emit_eabi_attribute ("Tag_ABI_align8_needed", 24, 1);
       arm_emit_eabi_attribute ("Tag_ABI_align8_preserved", 25, 1);
       arm_emit_eabi_attribute ("Tag_ABI_enum_size", 26,
-			       flag_short_enums ? 1 : 2);
+			       GCC_OPTION (flag_short_enums) ? 1 : 2);
 
       /* Tag_ABI_optimization_goals.  */
-      if (optimize_size)
+      if (GCC_OPTION (optimize_size))
 	val = 4;
-      else if (optimize >= 2)
+      else if (GCC_OPTION (optimize) >= 2)
 	val = 2;
-      else if (optimize)
+      else if (GCC_OPTION (optimize))
 	val = 1;
       else
 	val = 6;
       arm_emit_eabi_attribute ("Tag_ABI_optimization_goals", 30, val);
 
       arm_emit_eabi_attribute ("Tag_CPU_unaligned_access", 34,
-			       unaligned_access);
+			       GCC_OPTION (unaligned_access));
 
-      if (arm_fp16_format)
+      if (GCC_OPTION (arm_fp16_format))
 	arm_emit_eabi_attribute ("Tag_ABI_FP_16bit_format", 38,
-			     (int) arm_fp16_format);
+			     (int) GCC_OPTION (arm_fp16_format));
 
       if (arm_lang_output_object_attributes_hook)
 	arm_lang_output_object_attributes_hook();
@@ -28047,7 +28047,7 @@ arm_file_end (void)
 static void
 arm_encode_section_info (tree decl, rtx rtl, int first)
 {
-  if (optimize > 0 && TREE_CONSTANT (decl))
+  if (GCC_OPTION (optimize) > 0 && TREE_CONSTANT (decl))
     SYMBOL_REF_FLAG (XEXP (rtl, 0)) = 1;
 
   default_encode_section_info (decl, rtl, first);
@@ -28105,7 +28105,7 @@ arm_output_mi_thunk (FILE *file, tree thunk ATTRIBUTE_UNUSED,
 	}
       assemble_name (file, label);
       fputc ('\n', file);
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	{
 	  /* If we are generating PIC, the ldr instruction below loads
 	     "(target - 7) - .LTHUNKPCn" into r12.  The pc reads as
@@ -28177,7 +28177,7 @@ arm_output_mi_thunk (FILE *file, tree thunk ATTRIBUTE_UNUSED,
       ASM_OUTPUT_ALIGN (file, 2);
       assemble_name (file, label);
       fputs (":\n", file);
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	{
 	  /* Output ".word .LTHUNKn-7-.LTHUNKPCn".  */
 	  rtx tem = XEXP (DECL_RTL (function), 0);
@@ -28340,7 +28340,7 @@ arm_promote_function_mode (const_tree type ATTRIBUTE_UNUSED,
 static bool
 arm_default_short_enums (void)
 {
-  return TARGET_AAPCS_BASED && arm_abi != ARM_ABI_AAPCS_LINUX;
+  return TARGET_AAPCS_BASED && GCC_OPTION (arm_abi) != ARM_ABI_AAPCS_LINUX;
 }
 
 
@@ -28782,7 +28782,7 @@ arm_unwind_emit_sequence (FILE * asm_out_file, rtx p)
       e = XEXP (SET_DEST (e), 0);
       if (GET_CODE (e) == PLUS)
 	padfirst = INTVAL (XEXP (e, 1));
-      gcc_assert (padfirst == 0 || optimize_size);
+      gcc_assert (padfirst == 0 || GCC_OPTION (optimize_size));
       /* The function prologue may also push pc, but not annotate it as it is
 	 never restored.  We turn this into a stack pointer adjustment.  */
       e = XVECEXP (p, 0, nregs);
@@ -28954,7 +28954,7 @@ arm_unwind_emit (FILE * asm_out_file, rtx insn)
   if (arm_except_unwind_info (&global_options) != UI_TARGET)
     return;
 
-  if (!(flag_unwind_tables || crtl->uses_eh_lsda)
+  if (!(GCC_OPTION (flag_unwind_tables) || crtl->uses_eh_lsda)
       && (TREE_NOTHROW (current_function_decl)
 	  || crtl->all_throwers_are_sibcalls))
     return;
@@ -29088,7 +29088,7 @@ arm_output_fn_unwind (FILE * f, bool prologue)
       /* If this function will never be unwound, then mark it as such.
          The came condition is used in arm_unwind_emit to suppress
 	 the frame annotations.  */
-      if (!(flag_unwind_tables || crtl->uses_eh_lsda)
+      if (!(GCC_OPTION (flag_unwind_tables) || crtl->uses_eh_lsda)
 	  && (TREE_NOTHROW (current_function_decl)
 	      || crtl->all_throwers_are_sibcalls))
 	fputs("\t.cantunwind\n", f);
@@ -29368,7 +29368,7 @@ thumb2_output_casesi (rtx *operands)
     case HImode:
       return "tbh\t[%|pc, %0, lsl #1]";
     case SImode:
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	{
 	  output_asm_insn ("adr\t%4, %l2", operands);
 	  output_asm_insn ("ldr\t%5, [%4, %0, lsl #2]", operands);
@@ -29542,7 +29542,7 @@ arm_builtin_vectorized_function (tree fndecl, tree type_out, tree type_in)
 
   if (TREE_CODE (type_out) != VECTOR_TYPE
       || TREE_CODE (type_in) != VECTOR_TYPE
-      || !(TARGET_NEON && TARGET_FPU_ARMV8 && flag_unsafe_math_optimizations))
+      || !(TARGET_NEON && TARGET_FPU_ARMV8 && GCC_OPTION (flag_unsafe_math_optimizations)))
     return NULL_TREE;
 
   out_mode = TYPE_MODE (TREE_TYPE (type_out));
@@ -29611,7 +29611,7 @@ arm_vector_alignment_reachable (const_tree type, bool is_packed)
 {
   /* Vectors which aren't in packed structures will not be less aligned than
      the natural alignment of their element type, so this is safe.  */
-  if (TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access)
+  if (TARGET_NEON && !BYTES_BIG_ENDIAN && GCC_OPTION (unaligned_access))
     return !is_packed;
 
   return default_builtin_vector_alignment_reachable (type, is_packed);
@@ -29622,7 +29622,7 @@ arm_builtin_support_vector_misalignment (enum machine_mode mode,
 					 const_tree type, int misalignment,
 					 bool is_packed)
 {
-  if (TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access)
+  if (TARGET_NEON && !BYTES_BIG_ENDIAN && GCC_OPTION (unaligned_access))
     {
       HOST_WIDE_INT align = TYPE_ALIGN_UNIT (type);
 
@@ -29650,7 +29650,7 @@ arm_conditional_register_usage (void)
 {
   int regno;
 
-  if (TARGET_THUMB1 && optimize_size)
+  if (TARGET_THUMB1 && GCC_OPTION (optimize_size))
     {
       /* When optimizing for size on Thumb-1, it's better not
         to use the HI regs, because of the overhead of
diff --git a/gcc/config/arm/arm.h b/gcc/config/arm/arm.h
index 7ca47a7..9d95b31 100644
--- a/gcc/config/arm/arm.h
+++ b/gcc/config/arm/arm.h
@@ -51,7 +51,7 @@ extern char arm_arch_name[];
            builtin_define ("__ARM_FEATURE_SAT");	\
         if (TARGET_CRYPTO)				\
 	   builtin_define ("__ARM_FEATURE_CRYPTO");	\
-	if (unaligned_access)				\
+	if (GCC_OPTION (unaligned_access))				\
 	  builtin_define ("__ARM_FEATURE_UNALIGNED");	\
 	if (TARGET_CRC32)				\
 	  builtin_define ("__ARM_FEATURE_CRC32");	\
@@ -68,7 +68,7 @@ extern char arm_arch_name[];
 								\
 	builtin_define_with_int_value (				\
 	  "__ARM_SIZEOF_MINIMAL_ENUM",				\
-	  flag_short_enums ? 1 : 4);				\
+	  GCC_OPTION (flag_short_enums) ? 1 : 4);				\
 	builtin_define_with_int_value (				\
 	  "__ARM_SIZEOF_WCHAR_T", WCHAR_TYPE_SIZE);		\
 	if (TARGET_ARM_ARCH_PROFILE)				\
@@ -118,9 +118,9 @@ extern char arm_arch_name[];
 	if (TARGET_ARM_FP)				\
 	  builtin_define_with_int_value (		\
 	    "__ARM_FP", TARGET_ARM_FP);			\
-	if (arm_fp16_format == ARM_FP16_FORMAT_IEEE)		\
+	if (GCC_OPTION (arm_fp16_format) == ARM_FP16_FORMAT_IEEE)		\
 	  builtin_define ("__ARM_FP16_FORMAT_IEEE");		\
-	if (arm_fp16_format == ARM_FP16_FORMAT_ALTERNATIVE)	\
+	if (GCC_OPTION (arm_fp16_format) == ARM_FP16_FORMAT_ALTERNATIVE)	\
 	  builtin_define ("__ARM_FP16_FORMAT_ALTERNATIVE");	\
         if (TARGET_FMA)					\
           builtin_define ("__ARM_FEATURE_FMA");		\
@@ -245,28 +245,28 @@ extern void (*arm_lang_output_object_attributes_hook)(void);
 #endif
 
 /* Run-time Target Specification.  */
-#define TARGET_SOFT_FLOAT		(arm_float_abi == ARM_FLOAT_ABI_SOFT)
+#define TARGET_SOFT_FLOAT		(GCC_OPTION (arm_float_abi) == ARM_FLOAT_ABI_SOFT)
 /* Use hardware floating point instructions. */
-#define TARGET_HARD_FLOAT		(arm_float_abi != ARM_FLOAT_ABI_SOFT)
+#define TARGET_HARD_FLOAT		(GCC_OPTION (arm_float_abi) != ARM_FLOAT_ABI_SOFT)
 /* Use hardware floating point calling convention.  */
-#define TARGET_HARD_FLOAT_ABI		(arm_float_abi == ARM_FLOAT_ABI_HARD)
+#define TARGET_HARD_FLOAT_ABI		(GCC_OPTION (arm_float_abi) == ARM_FLOAT_ABI_HARD)
 #define TARGET_VFP		(arm_fpu_desc->model == ARM_FP_MODEL_VFP)
 #define TARGET_IWMMXT			(arm_arch_iwmmxt)
 #define TARGET_IWMMXT2			(arm_arch_iwmmxt2)
 #define TARGET_REALLY_IWMMXT		(TARGET_IWMMXT && TARGET_32BIT)
 #define TARGET_REALLY_IWMMXT2		(TARGET_IWMMXT2 && TARGET_32BIT)
-#define TARGET_IWMMXT_ABI (TARGET_32BIT && arm_abi == ARM_ABI_IWMMXT)
+#define TARGET_IWMMXT_ABI (TARGET_32BIT && GCC_OPTION (arm_abi) == ARM_ABI_IWMMXT)
 #define TARGET_ARM                      (! TARGET_THUMB)
 #define TARGET_EITHER			1 /* (TARGET_ARM | TARGET_THUMB) */
 #define TARGET_BACKTRACE	        (leaf_function_p () \
 				         ? TARGET_TPCS_LEAF_FRAME \
 				         : TARGET_TPCS_FRAME)
 #define TARGET_AAPCS_BASED \
-    (arm_abi != ARM_ABI_APCS && arm_abi != ARM_ABI_ATPCS)
+    (GCC_OPTION (arm_abi) != ARM_ABI_APCS && GCC_OPTION (arm_abi) != ARM_ABI_ATPCS)
 
-#define TARGET_HARD_TP			(target_thread_pointer == TP_CP15)
-#define TARGET_SOFT_TP			(target_thread_pointer == TP_SOFT)
-#define TARGET_GNU2_TLS			(target_tls_dialect == TLS_GNU2)
+#define TARGET_HARD_TP			(GCC_OPTION (target_thread_pointer) == TP_CP15)
+#define TARGET_SOFT_TP			(GCC_OPTION (target_thread_pointer) == TP_SOFT)
+#define TARGET_GNU2_TLS			(GCC_OPTION (target_tls_dialect) == TLS_GNU2)
 
 /* Only 16-bit thumb code.  */
 #define TARGET_THUMB1			(TARGET_THUMB && !arm_arch_thumb2)
@@ -339,7 +339,7 @@ extern void (*arm_lang_output_object_attributes_hook)(void);
 #define TARGET_USE_MOVT \
   (arm_arch_thumb2 \
    && (arm_disable_literal_pool \
-       || (!optimize_size && !current_tune->prefer_constant_pool)))
+       || (!GCC_OPTION (optimize_size) && !current_tune->prefer_constant_pool)))
 
 /* We could use unified syntax for arm mode, but for now we just use it
    for Thumb-2.  */
@@ -438,7 +438,7 @@ extern int arm_fpu_attr;
 #endif
 
 #define LARGEST_EXPONENT_IS_NORMAL(bits) \
-    ((bits) == 16 && arm_fp16_format == ARM_FP16_FORMAT_ALTERNATIVE)
+    ((bits) == 16 && GCC_OPTION (arm_fp16_format) == ARM_FP16_FORMAT_ALTERNATIVE)
 
 #ifndef ARM_DEFAULT_ABI
 #define ARM_DEFAULT_ABI ARM_ABI_APCS
@@ -654,9 +654,9 @@ extern int arm_arch_crc;
 #define STACK_BOUNDARY  (ARM_DOUBLEWORD_ALIGN ? DOUBLEWORD_ALIGNMENT : 32)
 
 #define PREFERRED_STACK_BOUNDARY \
-    (arm_abi == ARM_ABI_ATPCS ? 64 : STACK_BOUNDARY)
+    (GCC_OPTION (arm_abi) == ARM_ABI_ATPCS ? 64 : STACK_BOUNDARY)
 
-#define FUNCTION_BOUNDARY  ((TARGET_THUMB && optimize_size) ? 16 : 32)
+#define FUNCTION_BOUNDARY  ((TARGET_THUMB && GCC_OPTION (optimize_size)) ? 16 : 32)
 
 /* The lowest bit is used to indicate Thumb-mode functions, so the
    vbit must go into the delta field of pointers to member
@@ -681,7 +681,7 @@ extern int arm_arch_crc;
 
 #define CONSTANT_ALIGNMENT(EXP, ALIGN)				\
    ((TREE_CODE (EXP) == STRING_CST				\
-     && !optimize_size						\
+     && !GCC_OPTION (optimize_size)						\
      && (ALIGN) < BITS_PER_WORD * CONSTANT_ALIGNMENT_FACTOR)	\
     ? BITS_PER_WORD * CONSTANT_ALIGNMENT_FACTOR : (ALIGN))
 
@@ -698,11 +698,11 @@ extern int arm_arch_crc;
 
 /* Align global data. */
 #define DATA_ALIGNMENT(EXP, ALIGN)			\
-  ARM_EXPAND_ALIGNMENT(!optimize_size, EXP, ALIGN)
+  ARM_EXPAND_ALIGNMENT(!GCC_OPTION (optimize_size), EXP, ALIGN)
 
 /* Similarly, make sure that objects on the stack are sensibly aligned.  */
 #define LOCAL_ALIGNMENT(EXP, ALIGN)				\
-  ARM_EXPAND_ALIGNMENT(!flag_conserve_stack, EXP, ALIGN)
+  ARM_EXPAND_ALIGNMENT(!GCC_OPTION (flag_conserve_stack), EXP, ALIGN)
 
 /* Setting STRUCTURE_SIZE_BOUNDARY to 32 produces more efficient code, but the
    value set in previous versions of this toolchain was 8, which produces more
@@ -711,7 +711,7 @@ extern int arm_arch_crc;
    however the value should be left at 32.  ARM SDT Reference Manual (ARM DUI
    0020D) page 2-20 says "Structures are aligned on word boundaries".
    The AAPCS specifies a value of 8.  */
-#define STRUCTURE_SIZE_BOUNDARY arm_structure_size_boundary
+#define STRUCTURE_SIZE_BOUNDARY GCC_OPTION (arm_structure_size_boundary)
 
 /* This is the value used to initialize arm_structure_size_boundary.  If a
    particular arm target wants to change the default value it should change
@@ -1276,11 +1276,11 @@ enum reg_class
    when addressing quantities in QI or HI mode; if we don't know the
    mode, then we must be conservative.  */
 #define MODE_BASE_REG_CLASS(MODE)					\
-  (arm_lra_flag								\
+  (GCC_OPTION (arm_lra_flag)								\
    ? (TARGET_32BIT ? CORE_REGS						\
       : GET_MODE_SIZE (MODE) >= 4 ? BASE_REGS				\
       : LO_REGS)							\
-   : ((TARGET_ARM || (TARGET_THUMB2 && !optimize_size)) ? CORE_REGS	\
+   : ((TARGET_ARM || (TARGET_THUMB2 && !GCC_OPTION (optimize_size))) ? CORE_REGS	\
       : ((MODE) == SImode) ? BASE_REGS					\
       : LO_REGS))
 
@@ -1827,7 +1827,7 @@ enum arm_auto_incmodes
 #define CONSTANT_ADDRESS_P(X)  			\
   (GET_CODE (X) == SYMBOL_REF 			\
    && (CONSTANT_POOL_ADDRESS_P (X)		\
-       || (TARGET_ARM && optimize > 0 && SYMBOL_REF_FLAG (X))))
+       || (TARGET_ARM && GCC_OPTION (optimize) > 0 && SYMBOL_REF_FLAG (X))))
 
 /* True if SYMBOL + OFFSET constants must refer to something within
    SYMBOL's section.  */
@@ -1999,7 +1999,7 @@ enum arm_auto_incmodes
 
 #define CASE_VECTOR_PC_RELATIVE (TARGET_THUMB2				\
 				 || (TARGET_THUMB1			\
-				     && (optimize_size || flag_pic)))
+				     && (GCC_OPTION (optimize_size) || GCC_OPTION (flag_pic))))
 
 #define CASE_VECTOR_SHORTEN_MODE(min, max, body)			\
   (TARGET_THUMB1							\
@@ -2079,7 +2079,7 @@ enum arm_auto_incmodes
 
 /* False if short circuit operation is preferred.  */
 #define LOGICAL_OP_NON_SHORT_CIRCUIT				\
-  ((optimize_size)						\
+  ((GCC_OPTION (optimize_size))						\
    ? (TARGET_THUMB ? false : true)				\
    : (current_tune->logical_op_non_short_circuit[TARGET_ARM]))
 
@@ -2267,7 +2267,7 @@ extern int making_const_table;
    we're optimizing.  For Thumb-2 check if any IT instructions need
    outputting.  */
 #define FINAL_PRESCAN_INSN(INSN, OPVEC, NOPERANDS)	\
-  if (TARGET_ARM && optimize)				\
+  if (TARGET_ARM && GCC_OPTION (optimize))				\
     arm_final_prescan_insn (INSN);			\
   else if (TARGET_THUMB2)				\
     thumb2_final_prescan_insn (INSN);			\
diff --git a/gcc/config/arm/coff.h b/gcc/config/arm/coff.h
index 7deb238..d0ac6f1 100644
--- a/gcc/config/arm/coff.h
+++ b/gcc/config/arm/coff.h
@@ -58,7 +58,7 @@
    the code more efficient, but for Thumb-1 it's better to put them out of
    band unless we are generating compressed tables.  */
 #define JUMP_TABLES_IN_TEXT_SECTION					\
-   (TARGET_32BIT || (TARGET_THUMB && (optimize_size || flag_pic)))
+   (TARGET_32BIT || (TARGET_THUMB && (GCC_OPTION (optimize_size) || GCC_OPTION (flag_pic))))
 
 #undef  READONLY_DATA_SECTION_ASM_OP
 #define READONLY_DATA_SECTION_ASM_OP	"\t.section .rdata"
diff --git a/gcc/config/arm/elf.h b/gcc/config/arm/elf.h
index 2ac8c8d..94febda 100644
--- a/gcc/config/arm/elf.h
+++ b/gcc/config/arm/elf.h
@@ -87,7 +87,7 @@
   do								\
     {								\
       ARM_OUTPUT_FN_UNWIND (FILE, FALSE);			\
-      if (!flag_inhibit_size_directive)				\
+      if (!GCC_OPTION (flag_inhibit_size_directive))				\
 	ASM_OUTPUT_MEASURED_SIZE (FILE, FNAME);			\
     }								\
   while (0)
@@ -99,7 +99,7 @@
    the code more efficient, but for Thumb-1 it's better to put them out of
    band unless we are generating compressed tables.  */
 #define JUMP_TABLES_IN_TEXT_SECTION					\
-   (TARGET_32BIT || (TARGET_THUMB && (optimize_size || flag_pic)))
+   (TARGET_32BIT || (TARGET_THUMB && (GCC_OPTION (optimize_size) || GCC_OPTION (flag_pic))))
 
 #ifndef LINK_SPEC
 #define LINK_SPEC "%{mbig-endian:-EB} %{mlittle-endian:-EL} -X"
@@ -127,8 +127,8 @@
 #define TARGET_ASM_DESTRUCTOR arm_elf_asm_destructor
 
 /* For PIC code we need to explicitly specify (PLT) and (GOT) relocs.  */
-#define NEED_PLT_RELOC	flag_pic
-#define NEED_GOT_RELOC	flag_pic
+#define NEED_PLT_RELOC	GCC_OPTION (flag_pic)
+#define NEED_GOT_RELOC	GCC_OPTION (flag_pic)
 
 /* The ELF assembler handles GOT addressing differently to NetBSD.  */
 #define GOT_PCREL	0
diff --git a/gcc/config/avr/avr-c.c b/gcc/config/avr/avr-c.c
index 101d280..72edc55 100644
--- a/gcc/config/avr/avr-c.c
+++ b/gcc/config/avr/avr-c.c
@@ -338,7 +338,7 @@ avr_cpu_cpp_builtins (struct cpp_reader *pfile)
   else
     cpp_define (pfile, "__AVR_HAVE_16BIT_SP__");
 
-  if (avr_sp8)
+  if (GCC_OPTION (avr_sp8))
     cpp_define (pfile, "__AVR_SP8__");
 
   if (AVR_HAVE_SPH)
diff --git a/gcc/config/avr/avr-log.c b/gcc/config/avr/avr-log.c
index 8e27cec..4df7ba2 100644
--- a/gcc/config/avr/avr-log.c
+++ b/gcc/config/avr/avr-log.c
@@ -311,15 +311,15 @@ avr_log_set_avr_log (void)
 {
   bool all = TARGET_ALL_DEBUG != 0;
 
-  if (all || avr_log_details)
+  if (all || GCC_OPTION (avr_log_details))
     {
       /* Adding , at beginning and end of string makes searching easier.  */
 
-      char *str = (char*) alloca (3 + strlen (avr_log_details));
+      char *str = (char*) alloca (3 + strlen (GCC_OPTION (avr_log_details)));
       bool info;
 
       str[0] = ',';
-      strcat (stpcpy (str+1, avr_log_details), ",");
+      strcat (stpcpy (str+1, GCC_OPTION (avr_log_details)), ",");
 
       all |= NULL != strstr (str, ",all,");
       info = NULL != strstr (str, ",?,");
